#include <windows.h>
#include <string.h>
#include <stdio.h>
#include <stddef.h>
#include <time.h>
#include <math.h>
#include <fstream>
#include <iostream>
#include <stdlib.h>
#include "sgp4ext.h"
#include "sgp4unit.h"
#include "sgp4io.h"
#include "sgp4coord.h"
#define DLLEXPORT extern"C" __declspec(dllexport)
#pragma once
int WINAPI WinMain ( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR szComdLine, int iCmdShow);

using namespace std;

typedef char *PChar;
typedef PChar *StringParam[100];

// *** needed by PL to configure 'chip' pin's
DLLEXPORT unsigned char _stdcall NumInputs();
DLLEXPORT unsigned char _stdcall NumOutputs();
DLLEXPORT void _stdcall GetInputName(unsigned char Chan,  char *Name);
DLLEXPORT void _stdcall GetOutputName(unsigned char Chan,  char *Name);
// *** end 'chip' definition pin's (names assigned below)

// this is where the ACTION takes place...(main routine of DLL) implemented below
DLLEXPORT void _stdcall CCalculateEx(double *PInput, double *POutput, double *PUser, StringParam PStrings);

//SET UP SOME VARIABLES
    double ro[3];
    double vo[3];
    double recef[3];
    double vecef[3];
    char typerun, typeinput, opsmode;
    gravconsttype  whichconst;
    
    double sec, secC, jd, jdC, tsince, startmfe, stopmfe, deltamin;
    double tumin, mu, radiusearthkm, xke, j2, j3, j4, j3oj2;
    double latlongh[3]; //lat, long in rad, h in km above ellipsoid
    double siteLat, siteLon, siteAlt, siteLatRad, siteLonRad;
    double satLat,satLon,satAlt,satAz,satEl,satDist,satJd;
    double razel[3];
    double razelrates[3];
    int  year; int mon; int day; int hr; int min;
    int yearC; int monC; int dayC; int hrC; int minC;
    elsetrec satrec;
    
    bool readfromFile = true;
    
    FILE* fp;    
    char longstr1[80];
    char longstr2[80];
